window.Gleam.initSearch([{"doc":"sqlc_gen_gleam","title":"sqlc_gen_gleam","content":"# SQL -&gt; Gleam (sqlc-gen-gleam)\n\n[![Package Version](https://img.shields.io/hexpm/v/sqlc_gen_gleam)](https://hex.pm/packages/sqlc_gen_gleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/sqlc_gen_gleam/)\n\n# Project Status\n\n**this project is currently pre-alpha. it will be released under v1.0.0 once ready for usage.**\n\n# How it works\n\nThis library makes use of a [sqlc-gen-json plugin](https://github.com/daniellionel01/sqlc-gen-json),\nwhich it then converts into gleam code.\n\nSo in a simplified manner, the pipeline looks like this:\n```mermaid\ngraph LR\n    SQL[SQL Queries] -- sqlc-gen-json --&gt; JSON[JSON Schema]\n    JSON -- sql-gen-gleam --&gt; Gleam[Gleam Code]\n```\n\n# Installation\n\n```sh\n$ gleam add sqlc_gen_gleam@1\n```\n```sh\n$ gleam run -m sqlc_gen_gleam\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/sqlc_gen_gleam&gt;.\n\n# Development\n\n## 1. Database\n\nThere are scripts to spawn MySQL or PostgreSQL docker container:\n-  [MySQL Script](./scripts/mysql/docker.sh)\n-  [PostgreSQL Script](./scripts/psql/docker.sh)\n\nFor example:\n```sh\n$ ./scripts/mysql/docker.sh\n# or\n$ ./scripts/psql/docker.sh\n```\n\n## 2. Generating the JSON schema\nThis library uses the JSON schema, generated by [sqlc](https://sqlc.dev/), to generate gleam code.\nTo generate the JSON with the example schema &amp; queries:\n```sh\n$ ./scripts/sqlc.sh # wrapper for &quot;sqlc generate&quot; with additional parameters\n```\n\n## 3. Running the project and tests\n```sh\n$ gleam run   # Run the project\n$ gleam test  # Run the tests\n```\n\n# Acknowledgements\n- This project was heavily inspired by `squirrel` ([Hex](https://hex.pm/packages/squirrel), [GitHub](https://github.com/giacomocavalieri/squirrel)). Thank you [@giacomocavalieri](https://github.com/giacomocavalieri)!\n- Thank you to `sqlc`([GitHub](https://github.com/sqlc-dev/sqlc), [Website](https://sqlc.dev/))\n\n# License\n[Apache License, Version 2.0](./LICENSE)\n\n# Currently unsupported sqlc functionality\n\n- embeddeding structs (https://docs.sqlc.dev/en/stable/howto/embedding.html)\n","url":"index.html"},{"doc":"sqlc_gen_gleam/config","title":"Config","content":"pub type Config {\n  Config(json_file_path: String)\n}\n\nConfig(json_file_path: String)\n json_file_path - relative to project root directory\n\nSynonyms:\nsqlc_gen_gleam/config.Config\nsqlc_gen_gleam/config Config","url":"sqlc_gen_gleam/config.html#Config"},{"doc":"sqlc_gen_gleam/config","title":"get_json_file","content":"pub fn get_json_file(config: Config) -&gt; Result(String, FileError)\n\nSynonyms:\nsqlc_gen_gleam/config.get_json_file\nsqlc_gen_gleam/config get_json_file","url":"sqlc_gen_gleam/config.html#get_json_file"},{"doc":"sqlc_gen_gleam/config","title":"sqlc_gen_gleam/config","content":"","url":"sqlc_gen_gleam/config.html"},{"doc":"sqlc_gen_gleam","title":"main","content":"pub fn main() -&gt; Result(Nil, Nil)\n\nSynonyms:\nsqlc_gen_gleam.main\nsqlc_gen_gleam main","url":"sqlc_gen_gleam.html#main"},{"doc":"sqlc_gen_gleam","title":"sqlc_gen_gleam","content":"","url":"sqlc_gen_gleam.html"}]);